﻿namespace WebApp;

interface

uses
  System.Linq,
  System.Web,
  System.Web.UI,
  System.Collections.Generic,
  FirebirdSql.Data.Firebird;

type
  _Default = public partial class(System.Web.UI.Page)
  protected 
    method GridView1_DataBinding(sender: System.Object; e: System.EventArgs);
    method Page_Load(sender: System.Object; e: System.EventArgs);
    method GetDepartment : List<Department>;
  end;

implementation

method _Default.GetDepartment : List<Department>;
begin
  result :=  new List<Department>;
  var strConn : String := Properties.Settings.Default.strDatabase;

  var conn : FbConnection := new FbConnection(strConn);
  conn.Open;

  var comm : FbCommand := new FbCommand('select * from department order by department', conn);

  var dr : FbDataReader := comm.ExecuteReader;

  if (dr.HasRows) then
  begin
    
    while (dr.Read) do
    begin
      var d : Department := new Department;

      d.ID := dr.GetInt32(dr.GetOrdinal("DEPT_NO"));
      d.Name := dr.GetString(dr.GetOrdinal("DEPARTMENT"));
      d.Budget := dr.GetDouble(dr.GetOrdinal("BUDGET"));
      d.Location := dr.GetString(dr.GetOrdinal("LOCATION"));
      d.PhoneNumber := dr.GetString(dr.GetOrdinal("PHONE_NO"));

      result.Add(d);
    end;

  end;
end;

method _Default.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  if not IsPostBack then
     DataBind();
end;

method _Default.GridView1_DataBinding(sender: System.Object; e: System.EventArgs);
var
  list : List<Department>;
begin
  list := GetDepartment;
  GridView1.DataSource := list;
end;

end.
