namespace WebServiceXE;

interface

uses
  System,
  System.Web,
  System.Linq,
  System.Collections,
  System.Collections.Generic,
  FirebirdSql.Data.Firebird,
  System.Web.Services,
  System.Web.Services.Protocols;


type
  [WebService(&Namespace := 'http://tempuri.org/')]
  [WebServiceBinding(ConformsTo := WsiProfiles.BasicProfile1_1)]
  [System.ComponentModel.ToolboxItem(false)]
  WebService = public class(System.Web.Services.WebService)
  public
    method HelloWorld: string;
    method GetCountries : List<Country>;
    method GetDepartment : List<Department>;
    method GetBooks( year : Integer) : List<Book>;
  end;

implementation

[WebMethod]
method WebService.HelloWorld: string;
begin
  result := 'Hello World';
end;

[WebMethod]
method WebService.GetCountries : List<Country>;
begin

  result := new List<Country>;
  var strConn : String := Properties.Settings.Default.StrDatabase;

  var conn :  FbConnection := new FbConnection(strConn);
  conn.Open;

  var comm : FbCommand := new FbCommand('select * from country', conn);

  var dr : FbDataReader := comm.ExecuteReader;

  if (dr.HasRows) then
  begin
    
    while (dr.Read) do
    begin
      
      var c : Country := new Country;

      c.Name := dr.GetString(0);
      c.Currency := dr.GetString(1);

      result.Add(c);


    end;
  end;

end;

[WebMethod]
method WebService.GetDepartment : List<Department>;
begin

  result := new List<Department>;
  var strConn : String := Properties.Settings.Default.StrDatabase;

  var conn :  FbConnection := new FbConnection(strConn);
  conn.Open;

  var comm : FbCommand := new FbCommand('select * from department', conn);

  var dr : FbDataReader := comm.ExecuteReader;

  if (dr.HasRows) then
  begin
    
    while (dr.Read) do
    begin
      
      var d : Department := new Department;

      d.Name := dr.GetString(dr.GetOrdinal("DEPARTMENT"));
      d.Budget := dr.GetDouble(dr.GetOrdinal("BUDGET"));
      d.Location := dr.GetString(dr.GetOrdinal("LOCATION"));
      d.PhoneNumber := dr.GetString(dr.GetOrdinal("PHONE_NO"));

      result.Add(d);


    end;
  end;

end;

[WebMethod]
method WebService.GetBooks( year : Integer) : List<Book>;
var
  books : Array of Book := [ new Book('Programming and Problem Solving with Delphi', 'Mitchell C. Kerman', 2008),
                              new Book('Delphi Prism Manual de Referencia', 'Marco Santini and Andreano Lanusse', 2010),
                              new Book('Delphi 2010', 'Marco Cantu', 2008),
                              new Book('Learn Object Pascal with Delphi', 'Rachele, Warren', 2008),
                              new Book('RSS and Atom in Action', 'Manning', 2006)];
  listofbooks : sequence of Book;
begin
  if year > 0 then
  begin
    listofbooks := From book in books 
                      Where book.Year = year
                      Select book;
  end
  else
  begin
    listofbooks := From book in books 
                      Select book;
  end;

  result := listofbooks.AsEnumerable.Cast<Book>.ToList();
end;

end.